// PlugTest.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"

#ifdef STRICT							// Already defined by stdafx,
#undef STRICT							// so we avoid warning linking msg
#endif
#ifdef _MBCS							// The same as above
#undef _MBCS
#endif

#include "Max.h"						// Include MAX's main header file
#include "PlugTest.h"
#include "About.h"
#include "NodeInfo.h"

#include "PlugTest.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DLLEXPORT __declspec(dllexport)	// Facilite Function's Exportation Declaration


CPlugTestApp	theApp;					// Global Object representing the application
PlugPanel		thePlugPanel;			// The One and only One Plug Panel object
PlugDesc		thePlugDesc;

/////////////////////////////////////////////////////////////////////////////
// CPlugTestApp

BEGIN_MESSAGE_MAP(CPlugTestApp, CWinApp)
	//{{AFX_MSG_MAP(CPlugTestApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlugTestApp construction

CPlugTestApp::CPlugTestApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CPlugTestApp object
BOOL CPlugTestApp::InitInstance() 
{
	HINSTANCE	hInstance;
	
	//Get the DLL's HINSTANCE
	hInstance = AfxGetResourceHandle();
	thePlugPanel.hInstance = hInstance;

	//Init 3DS Max Custom Controls
	InitCustomControls(hInstance);

	//Init Win32 Controls
	InitCommonControls();

	return TRUE;				//CWinApp::InitInstance();
}

int CPlugTestApp::ExitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// 3DS Max Identification Callbacks
DLLEXPORT const TCHAR* LibDescription ()
{ 
	return _T("Test Plugin"); 
}

/////////////////////////////////////////////////////////////////////////////
// Return the Number of Classes present in the DLLs
DLLEXPORT int LibNumberClasses ()
{ 
	return 1;					//Return 1 because this DLL contains 1 plugin
}

/////////////////////////////////////////////////////////////////////////////
//Return the i'th Class Description Object
DLLEXPORT ClassDesc* LibClassDesc(int i)
{
	switch(i) {
    case  0:
		return &thePlugDesc;	//Return the Plugin's Description Object
		break;
    default:
		return 0;
        break;
	}
}

/////////////////////////////////////////////////////////////////////////////
// MAX API Version
DLLEXPORT ULONG LibVersion ()
{ 
	return (VERSION_3DSMAX);
}

/***************************************************************************
*                                                                           *
*                            Plugin Panel Class                             *
*                                                                           *
 ***************************************************************************/
// This class is the main class of the plugin (like the Dialog's class for
// dialog based application)
//
// A unique object of this class (called thePlugPanel) is globally instanced

////////////////////////////////////////////////////////////////////////////////
//Constructor
PlugPanel::PlugPanel()
{
}

////////////////////////////////////////////////////////////////////////////////
//Destructor
PlugPanel::~PlugPanel()
{
}

////////////////////////////////////////////////////////////////////////////////
// PlugPanel Dialog Procedure to handle User and System Interactions
static BOOL CALLBACK PlugPanelProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) {
		case WM_INITDIALOG:						//Panel's extra initialization
			thePlugPanel.Init(hWnd);
			break;
		case WM_DESTROY:						//Panel's extra destruction
			thePlugPanel.Destroy(hWnd);
			break;
		case WM_COMMAND :
			switch (LOWORD(wParam)) {			//Handle Panel's controls
				case IDC_ABOUT: {
					CAbout dlg;
					dlg.DoModal();
					break;}
				case IDC_PICK: {
					thePlugPanel.Pick();
					break;}
			}
			break;

		////////////////////////////////////////////////////////////////////////
		//The following lines are not necessary for MAX2 Plugins
		case WM_LBUTTONDOWN:
		case WM_LBUTTONUP:
		case WM_MOUSEMOVE:
			thePlugPanel.ip->RollupMouseMessage(hWnd, msg, wParam, lParam);
			break;
		////////////////////////////////////////////////////////////////////////

		default:
			return FALSE;
		}
	return TRUE;
}


////////////////////////////////////////////////////////////////////////////////
// Display the Plugin's Panel
void PlugPanel::BeginEditParams(Interface* ip, IUtil* iu)
{
	this->ip = ip;								//Get the Plugin's Interface
	this->iu = iu;								//Get the Utility Plugin's Interface

	//Display the plugin's Rollup Dialog
	hPanel = ip->AddRollupPage(hInstance, MAKEINTRESOURCE(IDD_PANEL),
		PlugPanelProc, _T("Test Plugin"),0);
}

////////////////////////////////////////////////////////////////////////////////
// Free the Plugins' Panel
void PlugPanel::EndEditParams(Interface *ip, IUtil *iu)
{
	this->iu = NULL;
	this->ip = NULL;

	//Remove the Rollup Dialog
	ip->DeleteRollupPage(hPanel);
	hPanel = NULL;
}

////////////////////////////////////////////////////////////////////////////////
// Panel Initialization callback
void PlugPanel::Init(HWND hWnd)
{
}

////////////////////////////////////////////////////////////////////////////////
// Panel Destruction callback
void PlugPanel::Destroy(HWND hWnd)
{
}

////////////////////////////////////////////////////////////////////////////////
// Called when the Pick Button is pushed
void PlugPanel::Pick()
{
	INode*		theNode;
	NodeInfo	dlg;

	//Display the HitByName dialog
	TestHitByNameDlgCallback myCallback;
	if (!ip->DoHitByNameDialog(&myCallback))	return;

	//Get the Selected Node Table and the nodes' number
	if (!myCallback.NodeTab.Count())			return;
	theNode = *myCallback.NodeTab.Addr(0);

	//Display the Node's Info Dialog
	dlg.theNode = theNode;
	dlg.DoModal();

}
