// PlugTest.h : main header file for the PLUGTEST DLL
//

#ifndef _PLUGTESTH
#define _PLUGTESTH

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "bmmlib.h"					// Bitmap lib
#include "utilapi.h"				// Utility Plugins lib
#include "istdplug.h"

#define  TESTPLUG_CLASS_ID Class_ID(0x24f21f8d, 0x59140b2b)

#include "resource.h"		// main symbols

/////////////////////////////////////////////////////////////////////////////
// CPlugTestApp
// See PlugTest.cpp for the implementation of this class
//

class CPlugTestApp : public CWinApp
{
public:
	CPlugTestApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPlugTestApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CPlugTestApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// PlugPanel, manage the Plugins' display panel
class PlugPanel : public UtilityObj {
	public:
		HINSTANCE		hInstance;
		IUtil*			iu;
		Interface*		ip;
		HWND			hPanel;

	public:
		// Constructor & Destructor
		PlugPanel();
		virtual ~PlugPanel();

		// Overides of the UtilityObj class
		void BeginEditParams(Interface* ip, IUtil* iu);
		void EndEditParams(Interface* ip, IUtil* iu);
		void DeleteThis()						{}
		void Init(HWND hWnd);
		void Destroy(HWND hWnd);

		//Specific Methods
		void Pick();
};

extern PlugPanel thePlugPanel;		// The One and only One object

////////////////////////////////////////////////////////////////////////////////
// PlugDesc, Plugin description class
class PlugDesc : public ClassDesc
{
public:
	int			IsPublic ()						{return 1;}
	void*		Create (BOOL loading = FALSE)	{return &thePlugPanel;}
	const		TCHAR* ClassName ()				{return _T("Test Plugin");}
	SClass_ID	SuperClassID ()					{return UTILITY_CLASS_ID;}
	Class_ID	ClassID ()						{return TESTPLUG_CLASS_ID;}
	const		TCHAR* Category ()				{return _T("Fatal Design");}

};

/////////////////////////////////////////////////////////////////////////////
// 3DS Max Standard Select-by-name Dialog Box Callback Class
class TestHitByNameDlgCallback : public HitByNameDlgCallback
{
	public:
		virtual TCHAR* dialogTitle()		{ return _T("Select a Node to get information from");}
		virtual TCHAR* buttonText()			{ return _T("Select");}
		virtual BOOL useFilter()			{return FALSE;}
		virtual BOOL useProc()				{ return TRUE;}
		virtual void proc(INodeTab &nodeTab){NodeTab = nodeTab;}
		virtual BOOL singleSelect()			{return TRUE;}

	public:
		INodeTab	NodeTab;
};

/////////////////////////////////////////////////////////////////////////////

#endif